package = "apileague"
version = "1.6.4"
source = {
	url = "https://github.com/ddsky/api-league-clients/tree/master/lua/.git"
}

description = {
	summary = "API client generated by OpenAPI Generator",
	detailed = [[
API League is a Hub for World Class APIs.]],
	homepage = "https://openapi-generator.tech",
	license = "Unlicense",
	maintainer = "OpenAPI Generator contributors",
}

dependencies = {
	"lua >= 5.2",
	"http",
	"dkjson",
	"basexx"
}

build = {
	type = "builtin",
	modules = {
		["apileague.api.art_api"] = "apileague/api/art_api.lua";
		["apileague.api.books_api"] = "apileague/api/books_api.lua";
		["apileague.api.food_api"] = "apileague/api/food_api.lua";
		["apileague.api.humor_api"] = "apileague/api/humor_api.lua";
		["apileague.api.knowledge_api"] = "apileague/api/knowledge_api.lua";
		["apileague.api.math_api"] = "apileague/api/math_api.lua";
		["apileague.api.media_api"] = "apileague/api/media_api.lua";
		["apileague.api.news_api"] = "apileague/api/news_api.lua";
		["apileague.api.storage_api"] = "apileague/api/storage_api.lua";
		["apileague.api.text_api"] = "apileague/api/text_api.lua";
		["apileague.api.web_api"] = "apileague/api/web_api.lua";
		["apileague.model.compute_nutrition_api_200_response"] = "apileague/model/compute_nutrition_api_200_response.lua";
		["apileague.model.compute_nutrition_api_200_response_ingredient_breakdown_inner"] = "apileague/model/compute_nutrition_api_200_response_ingredient_breakdown_inner.lua";
		["apileague.model.compute_nutrition_api_200_response_ingredient_breakdown_inner_nutrients_inner"] = "apileague/model/compute_nutrition_api_200_response_ingredient_breakdown_inner_nutrients_inner.lua";
		["apileague.model.convert_units_api_200_response"] = "apileague/model/convert_units_api_200_response.lua";
		["apileague.model.correct_spelling_api_200_response"] = "apileague/model/correct_spelling_api_200_response.lua";
		["apileague.model.detect_gender_by_name_api_200_response"] = "apileague/model/detect_gender_by_name_api_200_response.lua";
		["apileague.model.detect_language_api_200_response_inner"] = "apileague/model/detect_language_api_200_response_inner.lua";
		["apileague.model.detect_main_image_color_api_200_response_inner"] = "apileague/model/detect_main_image_color_api_200_response_inner.lua";
		["apileague.model.detect_sentiment_api_200_response"] = "apileague/model/detect_sentiment_api_200_response.lua";
		["apileague.model.detect_sentiment_api_200_response_document"] = "apileague/model/detect_sentiment_api_200_response_document.lua";
		["apileague.model.detect_sentiment_api_200_response_sentences_inner"] = "apileague/model/detect_sentiment_api_200_response_sentences_inner.lua";
		["apileague.model.extract_authors_api_200_response"] = "apileague/model/extract_authors_api_200_response.lua";
		["apileague.model.extract_authors_api_200_response_authors_inner"] = "apileague/model/extract_authors_api_200_response_authors_inner.lua";
		["apileague.model.extract_content_from_a_web_page_api_200_response"] = "apileague/model/extract_content_from_a_web_page_api_200_response.lua";
		["apileague.model.extract_dates_api_200_response"] = "apileague/model/extract_dates_api_200_response.lua";
		["apileague.model.extract_dates_api_200_response_dates_inner"] = "apileague/model/extract_dates_api_200_response_dates_inner.lua";
		["apileague.model.extract_entities_api_200_response"] = "apileague/model/extract_entities_api_200_response.lua";
		["apileague.model.extract_entities_api_200_response_entities_inner"] = "apileague/model/extract_entities_api_200_response_entities_inner.lua";
		["apileague.model.extract_news_api_200_response"] = "apileague/model/extract_news_api_200_response.lua";
		["apileague.model.extract_news_api_200_response_images_inner"] = "apileague/model/extract_news_api_200_response_images_inner.lua";
		["apileague.model.extract_news_api_200_response_videos_inner"] = "apileague/model/extract_news_api_200_response_videos_inner.lua";
		["apileague.model.extract_publish_date_api_200_response"] = "apileague/model/extract_publish_date_api_200_response.lua";
		["apileague.model.find_similar_books_api_200_response"] = "apileague/model/find_similar_books_api_200_response.lua";
		["apileague.model.generate_nonsense_word_api_200_response"] = "apileague/model/generate_nonsense_word_api_200_response.lua";
		["apileague.model.list_word_synonyms_api_200_response"] = "apileague/model/list_word_synonyms_api_200_response.lua";
		["apileague.model.pluralize_word_api_200_response"] = "apileague/model/pluralize_word_api_200_response.lua";
		["apileague.model.random_meme_api_200_response"] = "apileague/model/random_meme_api_200_response.lua";
		["apileague.model.random_poem_api_200_response"] = "apileague/model/random_poem_api_200_response.lua";
		["apileague.model.random_quote_api_200_response"] = "apileague/model/random_quote_api_200_response.lua";
		["apileague.model.random_riddle_api_200_response"] = "apileague/model/random_riddle_api_200_response.lua";
		["apileague.model.random_trivia_api_200_response"] = "apileague/model/random_trivia_api_200_response.lua";
		["apileague.model.read_key_value_from_store_api_200_response"] = "apileague/model/read_key_value_from_store_api_200_response.lua";
		["apileague.model.retrieve_page_rank_api_200_response"] = "apileague/model/retrieve_page_rank_api_200_response.lua";
		["apileague.model.retrieve_recipe_information_api_200_response"] = "apileague/model/retrieve_recipe_information_api_200_response.lua";
		["apileague.model.retrieve_recipe_information_api_200_response_credits"] = "apileague/model/retrieve_recipe_information_api_200_response_credits.lua";
		["apileague.model.retrieve_recipe_information_api_200_response_dietary_properties"] = "apileague/model/retrieve_recipe_information_api_200_response_dietary_properties.lua";
		["apileague.model.retrieve_recipe_information_api_200_response_ingredients_inner"] = "apileague/model/retrieve_recipe_information_api_200_response_ingredients_inner.lua";
		["apileague.model.retrieve_recipe_information_api_200_response_ingredients_inner_measures"] = "apileague/model/retrieve_recipe_information_api_200_response_ingredients_inner_measures.lua";
		["apileague.model.retrieve_recipe_information_api_200_response_instructions_inner"] = "apileague/model/retrieve_recipe_information_api_200_response_instructions_inner.lua";
		["apileague.model.retrieve_recipe_information_api_200_response_instructions_inner_steps_inner"] = "apileague/model/retrieve_recipe_information_api_200_response_instructions_inner_steps_inner.lua";
		["apileague.model.retrieve_recipe_information_api_200_response_nutrition"] = "apileague/model/retrieve_recipe_information_api_200_response_nutrition.lua";
		["apileague.model.retrieve_recipe_information_api_200_response_nutrition_ingredient_breakdown_inner"] = "apileague/model/retrieve_recipe_information_api_200_response_nutrition_ingredient_breakdown_inner.lua";
		["apileague.model.retrieve_recipe_information_api_200_response_scores"] = "apileague/model/retrieve_recipe_information_api_200_response_scores.lua";
		["apileague.model.retrieve_recipe_information_api_200_response_taste"] = "apileague/model/retrieve_recipe_information_api_200_response_taste.lua";
		["apileague.model.retrieve_recipe_information_api_200_response_times"] = "apileague/model/retrieve_recipe_information_api_200_response_times.lua";
		["apileague.model.score_readability_api_200_response"] = "apileague/model/score_readability_api_200_response.lua";
		["apileague.model.score_text_api_200_response"] = "apileague/model/score_text_api_200_response.lua";
		["apileague.model.score_text_api_200_response_interestingness"] = "apileague/model/score_text_api_200_response_interestingness.lua";
		["apileague.model.score_text_api_200_response_interestingness_subscores"] = "apileague/model/score_text_api_200_response_interestingness_subscores.lua";
		["apileague.model.score_text_api_200_response_readability"] = "apileague/model/score_text_api_200_response_readability.lua";
		["apileague.model.score_text_api_200_response_readability_mainscores"] = "apileague/model/score_text_api_200_response_readability_mainscores.lua";
		["apileague.model.score_text_api_200_response_readability_subscores"] = "apileague/model/score_text_api_200_response_readability_subscores.lua";
		["apileague.model.score_text_api_200_response_skimmability"] = "apileague/model/score_text_api_200_response_skimmability.lua";
		["apileague.model.score_text_api_200_response_skimmability_mainscores"] = "apileague/model/score_text_api_200_response_skimmability_mainscores.lua";
		["apileague.model.score_text_api_200_response_skimmability_subscores"] = "apileague/model/score_text_api_200_response_skimmability_subscores.lua";
		["apileague.model.score_text_api_200_response_style"] = "apileague/model/score_text_api_200_response_style.lua";
		["apileague.model.score_text_api_200_response_style_subscores"] = "apileague/model/score_text_api_200_response_style_subscores.lua";
		["apileague.model.search_books_api_200_response"] = "apileague/model/search_books_api_200_response.lua";
		["apileague.model.search_books_api_200_response_books_inner_inner"] = "apileague/model/search_books_api_200_response_books_inner_inner.lua";
		["apileague.model.search_drinks_api_200_response"] = "apileague/model/search_drinks_api_200_response.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner"] = "apileague/model/search_drinks_api_200_response_drinks_inner.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_credits"] = "apileague/model/search_drinks_api_200_response_drinks_inner_credits.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_ingredients_inner"] = "apileague/model/search_drinks_api_200_response_drinks_inner_ingredients_inner.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_ingredients_inner_measures"] = "apileague/model/search_drinks_api_200_response_drinks_inner_ingredients_inner_measures.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_ingredients_inner_measures_metric"] = "apileague/model/search_drinks_api_200_response_drinks_inner_ingredients_inner_measures_metric.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_ingredients_inner_measures_us"] = "apileague/model/search_drinks_api_200_response_drinks_inner_ingredients_inner_measures_us.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_instructions_inner"] = "apileague/model/search_drinks_api_200_response_drinks_inner_instructions_inner.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_instructions_inner_steps_inner"] = "apileague/model/search_drinks_api_200_response_drinks_inner_instructions_inner_steps_inner.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_instructions_inner_steps_inner_ingredients_inner"] = "apileague/model/search_drinks_api_200_response_drinks_inner_instructions_inner_steps_inner_ingredients_inner.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_nutrition"] = "apileague/model/search_drinks_api_200_response_drinks_inner_nutrition.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_nutrition_caloric_breakdown"] = "apileague/model/search_drinks_api_200_response_drinks_inner_nutrition_caloric_breakdown.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_nutrition_flavonoids_inner"] = "apileague/model/search_drinks_api_200_response_drinks_inner_nutrition_flavonoids_inner.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_nutrition_ingredient_breakdown_inner"] = "apileague/model/search_drinks_api_200_response_drinks_inner_nutrition_ingredient_breakdown_inner.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_nutrition_ingredient_breakdown_inner_nutrients_inner"] = "apileague/model/search_drinks_api_200_response_drinks_inner_nutrition_ingredient_breakdown_inner_nutrients_inner.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_nutrition_nutrients_inner"] = "apileague/model/search_drinks_api_200_response_drinks_inner_nutrition_nutrients_inner.lua";
		["apileague.model.search_drinks_api_200_response_drinks_inner_nutrition_weight_per_serving"] = "apileague/model/search_drinks_api_200_response_drinks_inner_nutrition_weight_per_serving.lua";
		["apileague.model.search_gifs_api_200_response"] = "apileague/model/search_gifs_api_200_response.lua";
		["apileague.model.search_gifs_api_200_response_images_inner"] = "apileague/model/search_gifs_api_200_response_images_inner.lua";
		["apileague.model.search_icons_api_200_response"] = "apileague/model/search_icons_api_200_response.lua";
		["apileague.model.search_jokes_api_200_response"] = "apileague/model/search_jokes_api_200_response.lua";
		["apileague.model.search_jokes_api_200_response_jokes_inner"] = "apileague/model/search_jokes_api_200_response_jokes_inner.lua";
		["apileague.model.search_memes_api_200_response"] = "apileague/model/search_memes_api_200_response.lua";
		["apileague.model.search_memes_api_200_response_memes_inner"] = "apileague/model/search_memes_api_200_response_memes_inner.lua";
		["apileague.model.search_news_api_200_response"] = "apileague/model/search_news_api_200_response.lua";
		["apileague.model.search_news_api_200_response_news_inner"] = "apileague/model/search_news_api_200_response_news_inner.lua";
		["apileague.model.search_recipes_api_200_response"] = "apileague/model/search_recipes_api_200_response.lua";
		["apileague.model.search_recipes_api_200_response_recipes_inner"] = "apileague/model/search_recipes_api_200_response_recipes_inner.lua";
		["apileague.model.search_recipes_api_200_response_recipes_inner_nutrition"] = "apileague/model/search_recipes_api_200_response_recipes_inner_nutrition.lua";
		["apileague.model.search_recipes_api_200_response_recipes_inner_nutrition_nutrients_inner"] = "apileague/model/search_recipes_api_200_response_recipes_inner_nutrition_nutrients_inner.lua";
		["apileague.model.search_restaurants_api_200_response"] = "apileague/model/search_restaurants_api_200_response.lua";
		["apileague.model.search_restaurants_api_200_response_restaurants_inner"] = "apileague/model/search_restaurants_api_200_response_restaurants_inner.lua";
		["apileague.model.search_restaurants_api_200_response_restaurants_inner_address"] = "apileague/model/search_restaurants_api_200_response_restaurants_inner_address.lua";
		["apileague.model.search_restaurants_api_200_response_restaurants_inner_local_hours"] = "apileague/model/search_restaurants_api_200_response_restaurants_inner_local_hours.lua";
		["apileague.model.search_restaurants_api_200_response_restaurants_inner_local_hours_operational"] = "apileague/model/search_restaurants_api_200_response_restaurants_inner_local_hours_operational.lua";
		["apileague.model.search_royalty_free_images_api_200_response"] = "apileague/model/search_royalty_free_images_api_200_response.lua";
		["apileague.model.search_royalty_free_images_api_200_response_images_inner"] = "apileague/model/search_royalty_free_images_api_200_response_images_inner.lua";
		["apileague.model.search_royalty_free_images_api_200_response_images_inner_license"] = "apileague/model/search_royalty_free_images_api_200_response_images_inner_license.lua";
		["apileague.model.search_web_api_200_response"] = "apileague/model/search_web_api_200_response.lua";
		["apileague.model.search_web_api_200_response_results_inner"] = "apileague/model/search_web_api_200_response_results_inner.lua";
		["apileague.model.singularize_word_api_200_response"] = "apileague/model/singularize_word_api_200_response.lua";
		["apileague.model.stem_text_api_200_response"] = "apileague/model/stem_text_api_200_response.lua";
		["apileague.model.store_key_value_getapi_200_response"] = "apileague/model/store_key_value_getapi_200_response.lua";
		["apileague.model.tag_part_of_speech_api_200_response"] = "apileague/model/tag_part_of_speech_api_200_response.lua";
		["apileague.model.top_news_api_200_response"] = "apileague/model/top_news_api_200_response.lua";
		["apileague.model.top_news_api_200_response_top_news_inner"] = "apileague/model/top_news_api_200_response_top_news_inner.lua";
		["apileague.model.top_news_api_200_response_top_news_inner_news_inner"] = "apileague/model/top_news_api_200_response_top_news_inner_news_inner.lua";
		["apileague.model.vector_search_api_200_response"] = "apileague/model/vector_search_api_200_response.lua";
		["apileague.model.vector_search_api_200_response_vectors_inner"] = "apileague/model/vector_search_api_200_response_vectors_inner.lua";
		["apileague.model.verify_email_address_api_200_response"] = "apileague/model/verify_email_address_api_200_response.lua";
	}
}
